import { outputFile } from 'fs-extra';
import { isStr } from '@spark-build/web-utils/lib/type';
import { spliceExportFrom } from '../../util';
export const stage = -8;
export default async function depsEntryExports(api) {
  api.registerMethod({
    name: 'addDepsEntryExports'
  });
  api.onGenerateFiles(async () => {
    const exports = await api.applyPlugins({
      key: 'addDepsEntryExports'
    });

    if (!exports.length) {
      return undefined;
    }

    const exportsToString = exports.map(text => isStr(text) ? text : spliceExportFrom(text.specifier || '*', text.source)).join('\n');
    return outputFile(api.resolveTmpPath('index.ts'), exportsToString);
  });
}