import { join } from 'path';
import * as fs from 'fs-extra';
import { isFn, isObj } from '@spark-build/web-utils/lib/type';
export const loadPlugins = async () => {
  const pluginsDirPath = join(__dirname, '../../../plugins');
  const files = await fs.readdir(pluginsDirPath);
  return Promise.all(files.map(async id => {
    const path = join(pluginsDirPath, id);

    try {
      const loadFileSetting = await new Promise((resolve, reject) => {
        try {
          resolve(require(path));
        } catch (error) {
          reject(error);
        }
      }).then(res => ({
        stage: res.stage || 0,
        fn: res.default
      }));
      return {
        id,
        path,
        ...loadFileSetting
      };
    } catch (e) {
      throw new Error(`Register ${id} ${path} failed, since ${e.message}`);
    }
  }));
};
export const isPromise = obj => (isObj(obj) || isFn(obj)) && isFn(obj.then);